#!BPY
""" Registration info for Blender menus
Name: 'ph_SymmSelect'
Blender: 232
Group: 'Misc'
Tooltip: 'Select symmetrical vertex.'
"""
#### <> !

####################################
#                                  #
#        ph_SymmSelect.py          #
#                                  #
# Cree par coolphil@worldonline.fr #
#       le 24/04/2004              #
#                                  #
####################################

import Blender
from Blender import Scene, Object, NMesh
from Blender.Draw import *
from Blender.BGL import *

only = 0

EVENT_EXIT = 1
EVENT_SYMM = 2

EVENT_ZERO = 3
EVENT_ONLY_Z = 4

EVENT_SYMM = 5
EVENT_ONLY_S = 6

EVENT_TOGG = 7

###############
def info_Obj():
###############

	Ob = []
	Obtype = 0
	mename = []
	me = []
	calque = 1

	if Object.GetSelected():
		Ob = Object.GetSelected()[0]
		if (Ob.getType() == 'Mesh'):

			Obtype = 1
			calque = Ob.Layer                    # Le "layer" de l'object selectionne
			mename = Ob.getData().name
			me = Ob.getData()

	return Ob,Obtype,mename,me

#################
def SelectVerts(list):
#################

	for v in list:
		v.sel = 1

	return 0

###################
def DeselectVerts(list):
###################

	for v in list:
		v.sel = 0

	return 0


###################
def ClassVerts(me):
###################

		D_co_Verts = {} ### {[ABSco]: NMVerts, NMVert} (ou ...: [None], NMVert ou ...:NMVert, [None]) ####
		D_co_SymVtx = {} ### {[ABSco]: Position } (Position = 0 ou 1 (soit negatif ou positif)) ####
		L_Zero_coX = [] ### liste des NMVerts ayant zero comme coordonees X ####
		L_SelVerts = [] ### liste des vertex selectionnes ####
		L_Symsel = [] ### liste des symmetriques NMVerts a selectionnes ####

		#### Classement #########
		for v in me.verts:
			if abs(round(v.co[0],4)) == 0.0:
				L_Zero_coX.append(v)
			else:
				if v.co[0] < 0.0:
					pos = 0
				else:
					pos = 1

				x = abs(round(v.co[0],4))
				y = round(v.co[1],4)
				z = round(v.co[2],4)

				if pos:
					if D_co_Verts.has_key((x,y,z)):
						D_co_Verts[x,y,z] = D_co_Verts[x,y,z][0], v
					else:
						D_co_Verts[x,y,z] = (None), v
				else:
					if D_co_Verts.has_key((x,y,z)):
						tp = D_co_Verts[x,y,z][1]
						D_co_Verts[x,y,z] = v, tp
					else:
						D_co_Verts[x,y,z] = v, (None)

				if v.sel:
						L_SelVerts.append(v)
						D_co_SymVtx[x,y,z] = (pos == 0)
						L_Symsel.append((x,y,z))

		return D_co_Verts, D_co_SymVtx, L_Zero_coX, L_SelVerts, L_Symsel


###########
def Symm():
###########
	global only

	Obj,Objtype,meshname,mesh = info_Obj()

	if Objtype:
		print
		print Obj

		######################
		co_Verts, co_SymVtx, Zero_coX, SelVerts, Symsel = ClassVerts(mesh)
		######################


		#### Selection de la symmetrie ############
		print "%s vertex selected" %len(SelVerts)
		for symv in Symsel:


			#### Current selection + Symmetrical selection ####
			if co_Verts[symv][co_SymVtx[symv]]:

				######################
				co_Verts[symv][co_SymVtx[symv]].sel = 1
				######################




		if only:
			#### Deselection de la selection originale ####
			DeselectVerts(SelVerts)
			print "Original vertex deselected !"
			print "New selection: %s vertex selected." %len(Symsel)
		else:
			print "New selection: %s vertex selected." %(len(SelVerts) + len(Symsel))



		mesh.update()
		Obj.makeDisplayList()

#################
def SelZeroVtx():
#################
	global only

	Obj,Objtype,meshname,mesh = info_Obj()

	if Objtype:
		print
		print Obj

		######################
		co_Verts, co_SymVtx, Zero_coX, SelVerts, Symsel = ClassVerts(mesh)
		######################

		print "%s vertex selected" %len(SelVerts)

		if only:
			#### Deselection de la selection originale ####
			DeselectVerts(SelVerts)
			print "Original vertex deselected !"


		#### Selection des vertex du milieu ####
		SelectVerts(Zero_coX)
		######
		if only:
			print "New selection: %s vertex selected." %len(Zero_coX)
		else:
			print "Middle vertex append to selection."
			print "New selection: %s vertex selected." %(len(Zero_coX) + len(SelVerts))


		mesh.update()
		Obj.makeDisplayList()


###########
def draw():
###########
	global EVENT_EXIT, EVENT_ZERO, EVENT_ONLY_Z, EVENT_SYMM, EVENT_ONLY_S


	color1 = (0.99, 0.99, 0.65)
	color2 = (0.567, 0.476, 0.365)
	color2Clear = (0.567, 0.476, 0.365, 1)
	color3 = (1.0, 1.0, 0.79)
	color4 = (0.265, 0.41, 0.4)
	color4Clear = (0.265, 0.41, 0.4, 1)
	color5 = (0.4, 0.472, 0.472)
	color6 = (0.5, 0.25, 0.25)
	color7 = (0.265, 0.4, 0.3)
	colorblack = (0.0, 0.0, 0.0)
	colorwhite = (1.0, 1.0, 1.0)
	colorred = (1.0, 0.0, 0.0)
	colorcyan = (0.0, 1.0, 1.0)
	colorgrey1 = (0.8, 0.8, 0.8)

	apply(glClearColor, color4Clear)
	glClear(GL_COLOR_BUFFER_BIT)

	apply(glColor3f, colorblack)
	glRecti(1, 1, 305, 155)
	apply(glColor3f, colorgrey1)
	glRecti(1, 1, 304, 156)
	apply(glColor3f, color7)
	glRecti(1, 1, 304, 155)

	apply(glColor3f, colorblack)
	glRecti(1, 150, 160, 122)
	apply(glColor3f, colorgrey1)
	glRecti(1, 151, 159, 124)
	apply(glColor3f, color6)
	glRecti(1, 150, 159, 123)


	apply(glColor3f, colorblack)
	glRasterPos2f(21, 132)
	Text("ph_SymmSelect.py")
	glRasterPos2f(21, 133)
	Text("ph_SymmSelect.py")
	apply(glColor3f, colorwhite)
	glRasterPos2f(20, 134)
	Text("ph_SymmSelect.py")

	Button("Exit", EVENT_EXIT, 245, 128, 50, 20, "Quit")

	apply(glColor3f, color1)
	glRecti(10, 13, 290, 33)

	Button("Append middleVerts", EVENT_ZERO, 20, 70, 120, 25, "Append middle vertex (with coX = 0.0) to selection.")
	Button("Only middleVerts", EVENT_ONLY_Z, 160, 70, 120, 25, "Select only middle vertex (with coX = 0.0).")

	apply(glColor3f, colorcyan)
	glRecti(10, 63, 290, 80)

	Button("Append SymmVerts", EVENT_SYMM, 20, 20, 120, 25, "Append symmetrical vertex to selection.")
	Button("Only SymmVerts", EVENT_ONLY_S, 160, 20, 120, 25, "Select only symmetrical vertex.")


####################
def event(evt, val):
####################
	if ( evt == ESCKEY and not val):
		Exit()

	if (evt== QKEY and not val):
		Exit()



################
def bevent(evt):
################
	global EVENT_EXIT, EVENT_ZERO, EVENT_ONLY_Z, EVENT_SYMM, EVENT_ONLY_S
	global only

	if (evt == EVENT_EXIT):
		Exit()


	if (evt == EVENT_ZERO):
		only = 0
		SelZeroVtx()

	if (evt == EVENT_ONLY_Z):
		only = 1
		SelZeroVtx()

	if (evt == EVENT_SYMM):
		only = 0
		Symm()


	if (evt == EVENT_ONLY_S):
		only = 1
		Symm()


######################
Register(draw, event, bevent)
######################
